		Eject
;===============================================================================
; File Created by SDCC : FreeWare ANSI-C Compiler
; Version 2.5.0 #1020 (May  8 2005)
; FP_LIB	Stand: 08.01.2006
;-------------------------------------------------------------------------------
		Public	_schar2fs
	        Public	_sint2fs
		Public	_slong2fs

		Public	_uchar2fs
		Public	_uint2fs
		Public	_ulong2fs

		Public	_fsadd
		Public	_fssub
		Public	_fsmul
		Public	_fsdiv
		Public	_fseq

		Public	_fs2uint
		Public	_fs2ulong
		Public	_fs2uchar
		
		Public	fs_compare_uint32
		Public	fs_check_negative_zeros
		Public	fs_normalize_a
		Public	fsgetargs
		Public	fs_swap_a_b
		Public	fs_rshift_a
		Public	fs_round_and_return
		Public	fs_zerocheck_return
		Public	fs_return_zero
		Public	fs_return_inf
		Public	fs_return_nan
		Public	fs_direct_return
;-------------------------------------------------------------------------------
Flag0		EQU	PSW.5
Flag1		EQU	PSW.1

ArgA0		EQU	R4		;LSB
ArgA1		EQU	R3
ArgA2		EQU	R2		;MSB
ArgA3		EQU	R1		;Exp.
;-------------------------------------------------------------------------------
MUL_		Macro	X, Y
		Mov	A, X
		MOV	B, Y
		MUL	AB		
		EndM

RLC_		Macro	Target
	        mov	a, Target
	        rlc	a
	        mov	Target, a
		EndM

ADD_		Macro	Reg, Number
		mov	a, Reg
		add	a, Number
		mov	Reg, a
		EndM

ADDC_		Macro	Reg, Number
		mov	a, Reg
		addc	a, Number
		mov	Reg, a
		EndM

SUBB_		Macro	Reg, Number
		mov	a, Reg
		addc	a, Number
		mov	Reg, a
		EndM

XCH_		Macro	X, Y
	        mov	a, X
	        xch	a, Y
	        mov	X, a
		EndM

;===============================================================================
;		List	Off
		Include	Macro.INC
;-------------------------------------------------------------------------------
fs_check_negative_zeros:
a_check:	cjne	a, #80H, a_not_neg_zero
		mov	a, b
		jnz	a_not_neg_zero_cleanup
		mov	a, dph
		jnz	a_not_neg_zero_cleanup
		mov	a, dpl
		jnz	a_not_neg_zero_cleanup
		mov	r7, #0
a_not_neg_zero_cleanup:
		mov	a, r7
a_not_neg_zero:
b_check:	cjne	@r0, #80H, b_not_neg_zero
		dec	r0
		cjne	@r0, #0, b_not_neg_zero_cleanup_1
		dec	r0
		cjne	@r0, #0, b_not_neg_zero_cleanup_2
		dec	r0
		cjne	@r0, #0, b_not_neg_zero_cleanup_3
		inc	r0
		inc	r0
		inc	r0
		mov	@r0, #0
		ret
b_not_neg_zero_cleanup_3:
		inc	r0
b_not_neg_zero_cleanup_2:
		inc	r0
b_not_neg_zero_cleanup_1:
		inc	r0
b_not_neg_zero:	ret 
;-------------------------------------------------------------------------------
	Cond	?fs_rshift_a
fs_rshift_a:	jz	RS00020
	        mov	r0, a
	        add	a, dpl
	        jnc	RS00001
	        mov	a, #255
RS00001:	mov	dpl, a
		mov	a, r0
		add	a, #248
		jnc	RS00003
		xch	a, r4
		xch	a, r3
		xch	a, r2
		mov	r1, a
		clr	a
		xch	a, r4
		add	a, #248
		jnc	RS00003
		xch	a, r3
		xch	a, r2
		mov	r1, a
		clr	a
		xch	a, r3
		add	a, #248
		jnc	RS00003
		xch	a, r2
		mov	r1, a
		clr	a
		xch	a, r2
		add	a, #248
		jnc	RS00003
		mov	r1, #0
		ret

RS00003:	add	a, #8
		jz	RS00020
		mov	r0, a
RS00005:	clr	c
		RRC_	r4
		RRC_	r3
		RRC_	r2
		RRC_	r1
		djnz	r0, RS00005
RS00020:	ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?fsgetarg
fsgetarg:	mov	r2, dpl
		mov	r3, dph
		mov	c, b.7
		rlc	a
		mov	Flag1, c
		jz	fsgetarg1
		setb	b.7
fsgetarg1:	mov	dpl, a
		mov	r4, b
		ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?fsgetargs
fsgetargs:	mov	r2, dpl
		mov	r3, dph
		mov	c, b.7
		rlc	a
		mov	Flag1, c
		jz	fsgetargs1
		setb	b.7
fsgetargs1:	mov	dpl, a
		mov	r4, b
		mov	a, sp
		add	a, #-7		;249
		mov	r0, a
		MOV	AR5, @R0
		inc	r0
		MOV	AR6, @R0
		inc	r0
		mov	b, @r0
		inc	r0
     		mov	a, @r0
		mov	c, b.7
		rlc	a
		mov	Flag0, c
		jz 	fsgetargs2
		setb	b.7
fsgetargs2:	mov	dph, a
	        mov	r7, b
	        ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?_schar2fs
_schar2fs:	mov	ArgA0, dpl
		clr	a
		mov	ArgA1, a
		mov	ArgA2, a
		mov	ArgA3, a
		mov	a, #126+8
	Cond	?_slong2fs | ?_sint2fs
		jmp	slong2fs_doit
	EndC
	EndC
;-------------------------------------------------------------------------------
	Cond	?_sint2fs
_sint2fs:	mov	ArgA0, dph
		mov	ArgA1, dpl
		clr	a
		mov	ArgA2, a
		mov	ArgA3, a
		mov	a, #126+16
	Cond	?_slong2fs
		jmp	slong2fs_doit
	EndC
	EndC
;-------------------------------------------------------------------------------
	Cond	?_slong2fs
_slong2fs:	mov	ArgA0, a
		mov	ArgA1, b
		mov	ArgA2, dph
		mov	ArgA3, dpl
		mov	a, #126+32
	EndC
;-------------------------------------------------------------------------------
	Cond	?_slong2fs | ?_sint2fs | ?_schar2fs
slong2fs_doit:	mov	dpl, a
		clr	Flag1
		mov	a, r4
		jnb	acc.7, slong2fs_positive
		setb	Flag1
		mov	a, r1
		cpl	a
		add	a, #1
		mov	r1, a
		mov	a, r2
		cpl	a
		addc	a, #0
		mov	r2, a
		mov	a, r3
		cpl	a
		addc	a, #0
		mov	r3, a
		mov	a, r4
		cpl	a
		addc	a, #0
		mov	r4, a
slong2fs_positive:
		jmp	fs_normalize_round_and_return
	EndC
;-------------------------------------------------------------------------------
	Cond	?_uchar2fs
_uchar2fs:	mov	ArgA0, dpl
		clr	a
		mov	ArgA1, a
		mov	ArgA2, a
		mov	ArgA3, a
		mov	a, #126+8
	Cond	?_ulong2fs | ?_uint2fs
		jmp	ulong2fs_doit
	EndC
	EndC
;-------------------------------------------------------------------------------
	Cond	?_uint2fs 
_uint2fs:	mov	ArgA0, dph
		mov	ArgA1, dpl
		clr	a
		mov	ArgA2, a
		mov	ArgA3, a
		mov	a, #126+16
	Cond	?_ulong2fs
		jmp	ulong2fs_doit
	EndC
	EndC
;-------------------------------------------------------------------------------
	Cond	?_ulong2fs
_ulong2fs:	mov	r4, a
		mov	r3, b
		mov	r2, dph
		mov	r1, dpl
		mov	a, #126+32
	EndC
	Cond	?_ulong2fs | ?_uint2fs | ?_uchar2fs
ulong2fs_doit:	clr	Flag1
		mov	dpl, a
		call fs_normalize_a
		jmp fs_round_and_return 
	EndC
;-------------------------------------------------------------------------------
	Cond	?fs_normalize_a
fs_normalize_a:	mov	r0, #4
		mov	a, r4
N00001:		jnz	N00003
		xch	a, r1
		xch	a, r2
		xch	a, r3
		mov	r4, a
		xch	a, dpl
		add	a, #-8		;248
		xch	a, dpl
		djnz	r0, N00001
		ret
	        
N00003:		mov	r0, #32
N00005:		jb	acc.7, N00006
		dec	dpl
		clr	c
		RLC_	r1
		RLC_	r2
		RLC_	r3
		RLC_	r4
	 	djnz	r0, N00005
N00006:		ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?_fs2uchar
_fs2uchar:	mov	r7, #126+8
		call	fs2ulong_begin
		mov	dpl, a
		ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?_fs2uint
_fs2uint:	mov	r7, #126+16
		call	fs2ulong_begin
		mov	dph, a
		mov	dpl, b
		ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?_fs2ulong
_fs2ulong:	mov	r7, #126+32
	EndC

	Cond	?_fs2uint | ?_fs2ulong | ?_fs2uchar
fs2ulong_begin: call	fsgetarg
		jnb	Flag1, fs2ulong_int
		jmp	fs_return_zero

fs2ulong_int:	clr	c
		mov	a, r7
		subb	a, dpl
		jnc	fs2ulong_int_ok
		; if we get here, x >= 2^32
		mov	a, #0FFH
		mov	b, a
		mov	dph, a
		mov	dpl, a
		ret

fs2ulong_int_ok:mov	r1, #0
		call	fs_rshift_a
fs2ulong_done:  mov	dpl, r1
		mov	dph, r2
		mov	b, r3
		mov	a, r4
		ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?_fssub
_fssub:		mov	r0, sp
		dec	r0
		dec	r0
		xch	a, @r0
		cpl	acc.7
		xch	a, @r0
	EndC
;-------------------------------------------------------------------------------
	Cond	?_fsadd | ?_fssub
_fsadd:		call fsgetargs
		mov	r1, #0
		mov	a, dph
		cjne	a, dpl, FA00005
		jmp	FA00011

FA00005:	jnc	FA00010
		call	fs_swap_a_b
FA00010:	mov	a, dph
		clr	c
		subb	a, dpl
		call	fs_rshift_a
FA00011:        mov	a, psw
		swap	a
		xrl	a, psw
		jb	acc.1, FA00022		;if Flag0 <> Flag1
FA00020:	ADD_	R2, R5
		ADDC_	R3, R6
		ADDC_	R4, R7
		jnc	FA00021
		mov	a, #1
		call	fs_rshift_a
		mov	a, r4
		orl	a, #80H
		mov	r4, a
FA00021:	jmp	fs_round_and_return

FA00022:	clr	c
	        mov	a, r2
	        subb	a, r5
	        mov	r2, a
	        mov	a, r3
	        subb	a, r6
	        mov	r3, a
	        mov	a, r4
	        subb	a, r7
	        mov	r4, a
	        jnc	FA00025
	        clr	c
	        clr	a
	        subb	a, r1
	        mov	r1, a
	        clr	a
	        subb	a, r2
	        mov	r2, a
	        clr	a
	        subb	a, r3
	        mov	r3, a
	        clr	a
	        subb	a, r4
	        mov	r4, a
	        cpl	Flag1
FA00025:	jmp	fs_normalize_round_and_return
	EndC
;-------------------------------------------------------------------------------
	Cond	?_fsmul
_fsmul:		call	fsgetargs
		cjne	r4, #0, FM00002
FM00001:	jmp	fs_return_zero

FM00002:	mov	a, r7
		jz	FM00001
		jnb	Flag0, FM00003
		cpl	Flag1
FM00003:	mov	a, dpl
		add	a, dph
		add	a, #130
		mov	dpl, a
		MUL_	R2, R5
		mov	r0, b
		MUL_	R2, R6

		add	a, r0
		mov	r0, a
		clr	a
		addc	a, b
		mov	r1, a
		MUL_	R3, R5
		add	a, r0
		ADDC_	R1, B

		clr	a
		rlc	a
		xch	a, r2
		mov	b, r7
		mul	ab
		add	a, r1
		mov	r1, a
		ADDC_	R2, B

		mov	a, r3
		mov	r0, a
		mov	b, r6
		mul	ab
		add	a, r1
		mov	r1, a
		ADDC_	R2, B

		clr	a
		rlc	a
		mov	r3, a
		MUL_	R4, R5
		add	a, r1
		mov	r1, a
		ADDC_	R2, B
		clr	a
		addc	a, r3
		mov	r3, a
		MUL_	R0, R7
		add	a, r2
		mov	r2, a
		ADDC_	R3, B

		clr	a
		rlc	a
		xch	a, r4
		mov	r5, a
		mov	b, r6
		mul	ab
		add	a, r2
		mov	r2, a
		ADDC_	R3, B
		clr	a
		addc	a, r4
		mov	r4, a

		MUL_	R5, R7
		add	a, r3
		mov	r3, a
		ADDC_	R4, B
		jb	acc.7, FM00010
		call	fs_normalize_a
FM00010: 	jmp	fs_round_and_return
	EndC
;-------------------------------------------------------------------------------
	Cond	?_fsdiv
_fsdiv:		call	fsgetargs
		jnb	Flag0, FD00001
		cpl	Flag1
FD00001:	cjne	r7, #0, FD00002
		jmp	fs_return_inf

FD00002:	cjne	r4, #0, FD00003
		jmp	fs_return_zero

FD00003:	clr	c
		mov	a, dpl
		subb	a, dph
		add	a, #127
		mov	dpl, a
		clr	c
		mov	a, r5
		subb	a, r2
		mov	a, r6
		subb	a, r3
		mov	a, r7
		subb	a, r4
		jc	FD00005
		dec	dpl
		clr	c
		mov	a, r2
		rlc	a
		mov	r1, a
		mov	a, r3
		rlc	a
		mov	r2, a
		mov	a, r4
		rlc	a
		mov	r3, a
		clr	a
		rlc	a
		mov	r4, a
		jmp	FD00006

FD00005:	clr	a
		xch	a, r4
		xch	a, r3
		xch	a, r2
		mov	r1, a
FD00006:	push	dpl
		mov	b, #25
FD00010:	clr	c
		mov	a, r1
		subb	a, r5
		mov	a, r2
		subb	a, r6
		mov	a, r3
		subb	a, r7
		mov	a, r4
		subb	a, #0
		djnz	b, FD00011
		jmp	FD00015

FD00011:	jc	FD00012
		mov	a, r1
		subb	a, r5
		mov	r1, a

		mov	a, r2
		subb	a, r6
		mov	r2, a

		mov	a, r3
		subb	a, r7
		mov	r3, a

		mov	a, r4
		subb	a, #0
		mov	r4, a

		clr	c
FD00012:	cpl	c
		RLC_	R0
		RLC_	DPL
		RLC_	DPH
		clr	c
		RLC_	R1
		RLC_	R2
		RLC_	R3
		RLC_	R4
		jmp	FD00010

FD00015:	cpl	c
		clr	a
		mov	r1, a
		addc	a, r0
		mov	r2, a
		clr	a
		addc	a, dpl
		mov	r3, a
		clr	a
		addc	a, dph
		mov	r4, a
		pop	dpl
		jnc	FD00016
		inc	dpl
		mov	r4, #80H
FD00016:	call	fs_normalize_a
		jmp	fs_zerocheck_return
	EndC
;-------------------------------------------------------------------------------
	Cond	?fs_swap_a_b
fs_swap_a_b:    XCH_	dpl, dph
		mov	c, Flag1
		rlc	a
		mov	c, Flag0
		mov	Flag1, c
		rrc	a
		mov	Flag0, c
		XCH_	R4, R7
		XCH_	R3, R6
		XCH_	R2, R5
		ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?fs_normalize_round_and_return
fs_normalize_round_and_return:
	        call	fs_normalize_a
	EndC

	Cond	?fs_round_and_return | ?fs_normalize_round_and_return
fs_round_and_return:
		cjne	r1, #128, RR00001
		mov	a, r2
		rrc	a
		cpl	c

RR00001:	jc	fs_zerocheck_return
		ADD_	R2, #1
		clr	a
		addc	a, r3
		mov	r3, a
		clr	a
		addc	a, r4
		mov	r4, a
		jnc	fs_zerocheck_return
		mov	r4, #80H
		inc	dpl

fs_zerocheck_return:
		cjne	r4, #0, fs_direct_return
		cjne	r3, #0, fs_direct_return
		cjne	r2, #0, fs_direct_return

fs_return_zero:	clr	a
		mov	dph, a
		mov	dpl, a
		mov	b,   a
		ret

fs_direct_return:
		mov	c, Flag1
		mov	a, dpl
		rrc	a
		mov	b, r4
		mov	b.7, c
		mov	dph, r3
		mov	dpl, r2
		ret

fs_return_inf:	clr	a
		mov	dph, a
		mov	dpl, a
		mov	b, #80H
		cpl	a
		mov	c, Flag1
		rrc	a
		ret

fs_return_nan:	clr	a
		mov	dph, a
		mov	dpl, a
		mov	b,   #0C0H
		mov	a,   #07FH
		ret
	EndC
;-------------------------------------------------------------------------------
	Cond	?_fseq
_fseq:		mov	r7, a
		mov	r0, sp
		dec	r0
		dec	r0
		call	fs_check_negative_zeros
		call	fs_compare_uint32
		mov	a, r1
		xrl	a, #1
		mov	dpl, a
		ret 
	EndC
;-------------------------------------------------------------------------------
	Cond	?fs_compare_uint32
fs_compare_uint32:
		mov	r1, #1
		mov	r2, dpl
		mov	a, @r0
		mov	dpl, r7
		cjne	a, dpl, compare32_done
		dec	r0
		mov	a, @r0
		cjne	a, b, compare32_done
		dec	r0
		mov	a, @r0
		cjne	a, dph, compare32_done
		dec	r0
		mov	a, @r0
		mov	dpl, r2
		cjne	a, dpl, compare32_done
		mov	r1, #0
compare32_done:	ret
	EndC
;-------------------------------------------------------------------------------
		END
