;Anschaltung
;Port	: 7  6  5  4  3  2  1  0
;LCD	: D7 D6 D5 D4 RW RS -- LE
;KEY	: K6 K5 K4 K3 K2 K1 KE -- ; 6 Tasten mit Diode, Kathoden an KE

; Command A to LCD
LCD_Set:	Call	IfBusy
		CLR	LCD_Port.2
		JMP	Wr8Bit
;-------------------------------------------------------------------------------		
; OUT A to LCD
LCD_Out:	Call	IfBusy
		SetB	LCD_Port.2		;RS
Wr8Bit:		CALL	WR4Bit
WR4Bit:		ANL	LCD_Port, #0000 0110B
		PUSH	A
		ANL	A,#1111 0000B
		ORL	LCD_Port, A
		POP	A
		SWAP	A
WrPuls:		SETB	LCD_Port.0
		CLR	LCD_Port.0
		RET

IsBusy:		CLR	LCD_Port.0
		SETB	LCD_Port.0
IfBusy:		MOV	LCD_Port,#1111 1010B	;read LCD, Key off
		SETB	LCD_Port.0
		JB	LCD_Port.7, IsBusy	;D7-D4
		CLR	LCD_Port.0
		JMP	WrPuls			;D3-D0
;-------------------------------------------------------------------------------
;Tastenabfrage
			;	     Key    LCD
GetKey:			;		\  /
		MOV	LCD_Port, #11111100B
		MOV	A, #11110110B		;no read LCD
		XCH	A, LCD_Port
		RR	A
		RR	A
		CPL	A
		ANL	A, #00111111B
		RET

